#!/usr/bin/env python
#-*- coding:utf-8 -*-

import random, os, sys
import traceback
from struct import unpack

import rfid

STDOUT = sys.stdout

def main():
    rfid.server(process_card)

def process_card(card):
    if card['type'] != "Mifare 1K":
        return deny("Bad card type")

    msg("Generating map...")

    xx = [0, 1]
    for i in xrange(14*12-1):
        xx.append(xx[i] + xx[i+1])

    msg("Picking random cell...")

    i = random.randint(1, 14)
    r = random.randint(0, 2)
    c = random.randint(0, 3)
    n = (i - 1) * 12 + r * 4 + c

    msg("Checking...")
    
    buf = card.read(i, r)
    if not buf:
        return deny("Can't read!")

    test = unpack("<I", buf[c*4:c*4+4])[0]
    
    if test != xx[n] & 0xffffffff:
        return deny("Check code mismatch, sorry!")

    msg("Ok, now you can use our compute machine!")
    msg("Calculating...")

    code = str(card.read(15, 0)) + str(card.read(15, 1)) + str(card.read(15, 2))
    code = code.rstrip("\x00")
    
    try:
        __builtins__ = __import__ = None
        os = sys = quit = locals = globals = None
        eval(code)
    except:
        traceback.print_exc(file=STDOUT)
    return deny("Calculation finished")

def deny(s):
    msg(s)
    msg("refresh")
    return

def msg(s):
    print "mutex IN"
    while len(os.listdir("../status/")): pass
    print "mutex OUT"
    open("../status/msg", "wb").write(s)

if __name__ == "__main__":
    main()
